import 'package:jiosaavn_wrapper/enum/artist_type.dart';

class Artist {
  final String id;
  final String name;
  final ArtistRole role;
  final String image;
  final String permaURL;
  final int? priority;

  String get token => permaURL.split('/').last;

  const Artist({
    required this.id,
    required this.name,
    required this.role,
    required this.image,
    required this.permaURL,
    this.priority = -1,
  });

  Artist copyWith({
    String? id,
    String? name,
    String? image,
    String? permaURL,
    ArtistRole? role,
    int? priority,
  }) {
    return Artist(
      id: id ?? this.id,
      name: name ?? this.name,
      image: image ?? this.image,
      permaURL: permaURL ?? this.permaURL,
      role: role ?? this.role,
      priority: priority ?? this.priority,
    );
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Artist &&
        other.id == id &&
        other.name == name &&
        other.image == image &&
        other.permaURL == permaURL;
  }

  @override
  int get hashCode {
    return id.hashCode ^ name.hashCode ^ image.hashCode ^ permaURL.hashCode;
  }

  @override
  String toString() {
    return 'Artist(id: $id, name: $name, image: $image, permaURL: $permaURL)';
  }
}
