class SearchResult {
  final List<AlbumSearchResult> albums;
  final List<SongSearchResult> songs;
  final List<PlaylistSearchResult> playlists;
  final List<ArtistSearchResult> artists;
  final List topQuery;

  const SearchResult({
    required this.albums,
    required this.songs,
    required this.playlists,
    required this.topQuery,
    required this.artists,
  });
}

class TopSearchResult {
  final List topQuery;

  TopSearchResult(this.topQuery);
}

class ArtistSearchResult {
  final String id;
  final String title;
  final String description;
  final SearchResultType type;
  final String image;

  const ArtistSearchResult({
    required this.id,
    required this.title,
    required this.description,
    required this.type,
    required this.image,
  });
}

class PlaylistSearchResult {
  final String id;
  final String title;
  final String subtitle;
  final SearchResultType type;
  final String image;
  final String permaURL;
  final String description;

  const PlaylistSearchResult({
    required this.id,
    required this.title,
    required this.subtitle,
    required this.type,
    required this.image,
    required this.permaURL,
    required this.description,
  });
}

class SongSearchResult {
  final String id;
  final String title;
  final String subtitle;
  final String description;
  final SearchResultType type;
  final String image;
  final String permaURL;
  final String album;
  final String primaryArtists;
  final String singers;
  final String previewMediaURL;

  const SongSearchResult({
    required this.id,
    required this.title,
    required this.subtitle,
    required this.description,
    required this.type,
    required this.image,
    required this.permaURL,
    required this.album,
    required this.primaryArtists,
    required this.singers,
    required this.previewMediaURL,
  });
}

class AlbumSearchResult {
  final String id;
  final String title;
  final String subtitle;
  final String description;
  final SearchResultType type;
  final String image;
  final String permaURL;
  final String pIds;
  final int year;

  const AlbumSearchResult({
    required this.id,
    required this.title,
    required this.subtitle,
    required this.description,
    required this.type,
    required this.image,
    required this.permaURL,
    required this.pIds,
    required this.year,
  });
}

enum SearchResultType {
  artist,
  playlist,
  song,
  album,
}
